unit main;

//{$mode delphi}
{$mode objfpc}{$H+}

interface

uses
    Classes, SysUtils, CustApp, jni;

const
  curClassPathName: string='';
  curClass: JClass=nil;
  curVM: PJavaVM=nil;
  curEnv: PJNIEnv=nil;

type
  {TApp}

  TApp = class(TCustomApplication)
   public
     procedure CreateForm(InstanceClass: TComponentClass; out Reference);
     constructor Create(TheOwner: TComponent); override;
     destructor Destroy; override;
  end;

  var
    App: TApp;

  //jni
  function JNI_OnLoad(VM: PJavaVM; reserved: pointer): JInt; {$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
  procedure JNI_OnUnload(VM: PJavaVM; reserved: pointer);{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
  //
  function getString(PEnv: PJNIEnv; this: JObject; flag: JInt): JString;{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
  function getSum(PEnv: PJNIEnv; this: JObject; x: JInt; y: JInt): JInt; {$ifdef mswindows}stdcall;{$else}cdecl;{$endif}

implementation

{TApp}

procedure TApp.CreateForm(InstanceClass: TComponentClass; out Reference);
var
  Instance: TComponent;
begin
  Instance := TComponent(InstanceClass.NewInstance);
  TComponent(Reference):= Instance;
  Instance.Create(Self);
end;

constructor TApp.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  StopOnException:=True;
end;

destructor TApp.Destroy;
begin
  inherited Destroy;
end;



{ Class:     org_jmpessoa_appantnoguidemo1_JNIHello
  Method:    getString
  Signature: (I)Ljava/lang/String; }
function getString(PEnv: PJNIEnv; this: JObject; flag: JInt): JString;{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
begin
  case flag  of
    1: Result:= (PEnv^^).NewStringUTF(PEnv, '<!DOCTYPE html> '+
      '<html>  '+
      '<body> '+
      '<h4>My First  (CodeTyphon, JavaScrip - ZELJUS&USB)</h4> '+
      '<p>Click the button to display the date.time</p> '+
       '<p>crate pascal script </p> '+
      '<p id="demo"></p> '+
      '<button type="button" onclick="myFunction()">Try it</button> '+
      '<script> '+
      'function myFunction() '+
      '{ '+
      'document.getElementById("demo").innerHTML = Date();'+
      '} '+
      '</script> '+
      '</body> '+
      '</html>' );
  end;
end;

{ Class:     org_jmpessoa_appantnoguidemo1_JNIHello
  Method:    getSum
  Signature: (II)I }
function getSum(PEnv: PJNIEnv; this: JObject; x: JInt; y: JInt): JInt; {$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
begin
  Result:= x + y;
end;

const NativeMethods:array[0..1] of JNINativeMethod = (
   (name:'getString';
    signature:'(I)Ljava/lang/String;';
    fnPtr:@getString;),
   (name:'getSum';
    signature:'(II)I';
    fnPtr:@getSum;)
);

function RegisterNativeMethodsArray(PEnv: PJNIEnv; className: PChar; methods: PJNINativeMethod; countMethods:integer):integer;
begin
  Result:= JNI_FALSE;
  curClass:= (PEnv^^).FindClass(PEnv, className);
  if curClass <> nil then
  begin
    if (PEnv^^).RegisterNatives(PEnv, curClass, methods, countMethods) > 0 then Result:= JNI_TRUE;
  end;
end;

function RegisterNativeMethods(PEnv: PJNIEnv): integer;
begin
  curClassPathName:= 'org/zeljus/JNIHello';
  Result:= RegisterNativeMethodsArray(PEnv, PChar(curClassPathName), @NativeMethods[0], Length(NativeMethods));
end;

function JNI_OnLoad(VM: PJavaVM; reserved: pointer): JInt; {$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
var
  PEnv: PPointer {PJNIEnv};
begin
  PEnv:= nil;
  Result:= JNI_VERSION_1_6;
  (VM^^).GetEnv(VM, @PEnv, Result);
  if PEnv <> nil then RegisterNativeMethods(PJNIEnv(PEnv));
  curVM:= VM {PJavaVM};
  curEnv:= PJNIEnv(PEnv);
end;

procedure JNI_OnUnload(VM: PJavaVM; reserved: pointer);{$ifdef mswindows}stdcall;{$else}cdecl;{$endif}
begin
  if curEnv <> nil then (curEnv^^).UnregisterNatives(curEnv, curClass);
  curClass:= nil;
  curEnv:= nil;
  curVM:= nil;
  App.Terminate;
  FreeAndNil(App);
end;

end.

